// C.Dupaty 06-2010
// TEST UTiL BUSA (RS485) sur PICDEM2+ avec P18F4620 en mode EMISSION DE CODE BADGE
// Horloge interne 8MHz avec PLLx4 soit FOSC=32MHz
// utilise libUSART, bibliotheque de reception USART en IT
// attention 19200,n,8,1
// gere tempo aprs reception de etx depuis UtIL
// 60ms aprs ETX + (N-1)*22mS
// Sur PICDEM2+ , affichage du code badge emit 
// Sur PICDEM2+ S2 et S3 envoient deux codes diffrents (util_mdp1.h)
// fichiers  lier avec ce programme
//  init_horloge_interne.c
//  lib_rs485_util.c
//  libusart.c
//  xlcd.c
//  xlcd_delays_stdio.c

// Ce programme et ses bibliotheques peuvent etre tests sur PICDEM2+ avec
// connecte a Util et logiciel TILMAN

#include <p18f4620.h>
#include <stdio.h>  	// pour fprintf
#include "xlcd.h"		// lib creee avec MAESTRO pour LCD sur PICDEL2+
						// tempos et redirection dans xlcd_delays_stdio.c
#include "init_horloge_interne.h"	// configuration FOSC=32MHz FOSC/4=8MHz
#include "util_mdp1.h"
#include "libusart.h"

#define S3	PORTBbits.RB0	// deux boutons pour test deux codes badges
#define S2 	PORTAbits.RA4

#define LOBYTE(arg)    (arg & 0xFF)
#define HIBYTE(arg)   ((unsigned char)(arg >> 8))

unsigned char ptr_mess[40];		// tampon pour le message

const unsigned char num_id[]="BTS-SE"; // "MDP1-A" a l'origine, ID contient 6 caractres
const unsigned char num_badge1[]="1234567890"; //code badge 10 chiffres
const unsigned char num_badge2[]="2143658709"; 


// PROGRAMME PRINCIPAL

void main(void)
{
unsigned int i;
unsigned char x=0;
	init_horloge_interne();		// pour horloge interne sur P18F4620
 	XLCDInit();			// initialise aff LCD (lib MAESTRO)
	init_rs485();		// initialise communications sur BUS A (ou B)

// DEMO EMISSION CODE BADGE
	TRISB=0xFF;		// PORTS en entree pour S2 et S3
	TRISAbits.TRISA4=1;

	XLCDCommand(0x0E);	// curseur clignotant OFF  
	XLCDL1home();
	fprintf(_H_USER,"S2 Bad1 S3 Bad2");
	XLCDL2home();
	fprintf(_H_USER,"%s %X %X N:%d",num_id,version,fab,mdp);
	while(S2);		// attente appui sur S2
	while(!S2);
	emission_UTIL(id,num_id);	// le MDP1 emet sont identifiant
	while(1)
		{	
			if (!S2) {
						emission_UTIL(badge,num_badge1);
						XLCDL1home();
						fprintf(_H_USER,"%s",num_badge1);
					}		 
			if (!S3) {
						emission_UTIL(badge,num_badge2);
						XLCDL1home();
						fprintf(_H_USER,"%s",num_badge2);
					}
			if (carUSARTdispo())	// un octet est dans le tampon de reception
				{
				 i=decode_mess_UTIL(ptr_mess);
				 switch(i)
					{
						 case 0:    break;  //  reception en cours
						 case 1:	XLCDL1home(); 	// message texte pour ligne 1 de l'afficheur		
									fprintf(_H_USER,"%s",ptr_mess);
									break;			
						 case 2:	XLCDL2home();	// message texte pour ligne 2 de l'afficheur
						      		fprintf(_H_USER,"%s",ptr_mess);
									break;	   
						 default:  // une commande est arrivee
									XLCDL2home();
									fprintf(_H_USER,"R V S2 Rel %04B    ",HIBYTE(i)&0x0F);
									break;	
					}
				}
		}
}
	
