// C.Dupaty 06/2010
// bibliotheque de simulation MDP1A
#include "util_mdp1.h"				// config MDP1A et RS485
#include "libusart.h"	// gestion des communications asynchrones en interruption


void init_rs485(void)
{
	initsci();					// tampon et interruptions
	TRISsens=0;					// choix RS485 TX RX en sortie	
	sensRS485=RX485;			// RX485 reception
	T1CON=0b10110001;			// T1 run 16bits prediv=8 H=FOSC/4=125nS donc T=1uS
	T3CONbits.T3CCP2=0;
	CCP1CON=0b00001011;					// CCP1 compare special event
	CCPR1L=0x4E;						// 20mS = 20000x1uS = 0x4E20 
	CCPR1H=0x20;
}

void tempo20mS(void)
{
// tempo 20mS
		TMR1L=0;
		TMR1H=0;
		PIR1bits.CCP1IF=0;
		while(!PIR1bits.CCP1IF);
}

void emission_UTIL(unsigned char entete,unsigned char * ch)
{
unsigned char c,chek;
unsigned int i;
// tempo 60mS aprs reception stop UTiL
	tempo20mS();
	tempo20mS();
	tempo20mS();
// tempo mdp x 20mS avant prise de ligne
	c=mdp;
	while(c)
		{
			tempo20mS();
			c--;
		}
	sensRS485=TX485;
	chek=0;
	putsci(stx_mdp);	// debut message
	putsci(0xD0+mdp-1);	// identification MDP1A + numero
	chek+=0xD0+mdp-1;
	putsci(entete); 		// ?
	chek+=entete;
	while (*ch)
		{	
			putsci(*ch);
			chek+=*ch;
			ch++;
		}
	if (entete==id)
		{
			putsci(version);
			chek+=version;
			putsci(fab);
			chek+=fab;
		}
	putsci(chek); 	// cheksum
	putsci(etx);	// fin de message
	i=500;	//300uS, tempo pour fin emission avant passage mode reception
	while(i--);
	sensRS485=RX485;
}



// decode le message reu et le place dans le pointeur mess
// retourne 0 si le message n'a pas t correctement reu
// retourne 1 pour un message sur ligne 1 afficheur
// retourne 2 pour un message sur ligne 2 afficheur
// retourne deux octets de configuration sinon
unsigned int decode_mess_UTIL(unsigned char *mess)
{
static unsigned char etat=1,cpt_entete=0,cpt_mdp; // variables pour machine d etat et compteur d 'entete	
static unsigned char * ptmess; // pointeur pour rangement dans mess
static unsigned char ordre1,ordre2;
unsigned char c;		// caratere recu et a traiter
unsigned int r;			// valeur renvoyee par la fonction
unsigned char ligne;

c=getsci();		// caractre  traiter
switch (etat)
	{
	case 1:		if (c == stx_util) etat=2; 
				if (c == entete_mess) {
									cpt_entete++;
									etat=7; 
								}				
				r=0;
				break;
	case 2:	 	if (c == 0xFC) etat=3; else etat=1;
				r=0;
				break;
	case 3:	 	if (c == 0x20) {
								cpt_mdp=0;	
								etat=4;
								}							
				 				else etat=1;
				r=0;
				break;
	case 4:		if (++cpt_mdp == (2*mdp)-1) {
										ordre1=c;
										etat=5;
									  }		
				r=0;
				break;
	case 5:		ordre2=c;					  
				etat=6;
				r=((unsigned int)ordre1<<8)+ordre2;
				break;
	case 6 :	if (c==etx) etat=1;
				r=0;
				break;
	case 7 : 	// attend 5 fois 0x01 si message pour afficheur (1 fois trouv dj)
				if (c == entete_mess) cpt_entete++;
				else cpt_entete=0;
				if (cpt_entete>=5) 	{
										cpt_entete=0;
										etat=8;
									}					
				r=0;
				break;
	case 8	:	// identifie numero afficheur sur BUSA 
				if ((++c) == (0xC0 + mdp)) etat=9;
				else etat=1;
				r=0;
				break;
	case 9	:	// identifie ligne afficheur
				ligne=(c&0x0F)+1;
				ptmess=mess;	// pointe le premier octet du tampon 
				etat=10;
				r=0;
				break;
	case 10	: 	// reception message a afficher
				if (c!=etx) *(ptmess++)=c;
				else {
						etat=1;
						*(--ptmess)=0; // fin chaine ASCII
						if (ligne==1) r=1;	// un message a t recu
						else r=2;
					}	
				break;
	}
return(r);
}