// C.Dupaty 06/2010
// header communication UTIL - MDP1A
#ifndef __utilmdp1_H
#define __utilmdp1_H

#include <p18cxxx.h>

// equivalences pour bibliotheque  NE PAS MODIFIER
#define sensRS485 PORTDbits.RD7 // sens des comm 0 pour IN 1 pour OUT
#define TRISsens TRISDbits.TRISD7 //definit le sens des communication sur TL1785
#define RX485 0		// reception
#define TX485 1		// emission

#define stx_mdp	2			// debut message mdp
#define etx 3			// fin message
#define stx_util 4		// debut message util
#define entete_mess 1	// caractere pour entete message (4 fois 1)
#define id	0xF0	// entete identifiant MDP1A	 
#define badge 0xA0 	// entete code badge MDP1A
#define es 0x20		// entete etat E/S MDP1A
#define mS140 35000	// 35000*4=140000uS	
#define comm_RELAIS 1  // commande relais=1 MDP1A
#define comm_S2 2 	// commande S2 MDP1A
#define comm_LEDV 4	// commande LED verte lecteur badge MDP1A
#define comm_LEDR 8	// commande LED rouge lecteur badge MDP1A


// parametres MDP1A a definir par l'utilisateur
#define mdp	7	// numero du MDP1A (roue codeuse 1  8)
#define version 0x21 // exemple pour version 2.1
#define fab 0x59	 // code inconnu ??? 06 donne 5.6 et 46 donne 12.0


// prototypes bibliotheque
void init_rs485(void);
void tempo140mS(void);
void emission_UTIL(unsigned char entete,unsigned char * ch);
unsigned int decode_mess_UTIL(unsigned char *mess);

#endif